/********************************************************************
 *	EUSART ֐.
 ********************************************************************
 */
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "HardwareProfile.h"
#include "eusart.h"



/********************************************************************
 *
 ********************************************************************
 */

#if	USART_USE_INTERRUPT			// 荞݂gp.


#define	RXBUF_SIZE		256
#define	RXBUF_SIZEMASK	(RXBUF_SIZE-1)


#pragma udata access accessram

uchar near rxReadPtr;
uchar near rxWritePtr;

extern	uchar near	LastRS232Out;  // Number of	characters in the buffer
extern	uchar near	RS232cp;	   // current position within the buffer

#ifdef	__18F14K50
  #pragma	udata	RXBUF=0x100			// 18F14K50̂݁A[ߖ̂0`0x5fɒu.
#else
  #pragma	udata				// 18F14K50̂݁A[ߖ̂0`0x5fɒu.
#endif

uchar USART_rxbuf[RXBUF_SIZE];	// MFIFO.

#pragma	udata

extern	char 	RS232_Out_Data[];

#endif	//USART_USE_INTERRUPT			// 荞݂gp.




/********************************************************************
 *
 ********************************************************************
 */
#pragma	code

#if	USART_USE_INTERRUPT			// 荞݂gp.

//	--------------------------------
//		荞݂gp.
//	--------------------------------

/********************************************************************
 *	Mobt@̂Ƃ 0 Ԃ.
 ********************************************************************
 *	łȂꍇ͎Mobt@ɗ܂Ă镶Ԃ.
 */
char  mDataRdyUSART(void)
{
	return ( rxWritePtr - rxReadPtr ) & RXBUF_SIZEMASK;
}

/********************************************************************
 *	PM
 ********************************************************************
 */
uchar getcUSART()
{
	uchar c=0; 			   			// Mf[^擾.
	uchar ptr = rxReadPtr;			// FIFOǂݎ|C^.

	if(ptr != rxWritePtr) {			// f[^FIFOɗ܂Ă.
		c = USART_rxbuf[ptr];		// FIFȌ݃|C^.
		ptr++; 
		ptr &= RXBUF_SIZEMASK;
		rxReadPtr = ptr;
	}
	return c;
}


void  USART_RxIntHandler(void)
{
	uchar c;
	
	// ɃG[.
	if (RCSTAbits.OERR) { 	//	in case	of overrun error
					//	we should never	see	an overrun error, but if we	do,	
		RCSTAbits.CREN = 0;	 //	reset the port
		c =	RCREG;
		RCSTAbits.CREN = 1;	 //	and	keep going.
	}

	// Mf[^Ύo.
	if(	PIR1bits.RCIF ) {
		uchar ptr   = rxWritePtr;		// FIFO݃|C^.

		USART_rxbuf[ptr] = RCREG;		// Mf[^擾.

		ptr++; 							// FIFO݃|C^XV\.
		ptr &= RXBUF_SIZEMASK;
		// 
		if(	ptr != rxReadPtr ) {		// FIFOtłȂ΃|C^XV.
			rxWritePtr = ptr;
		}

		/* Clear the interrupt flag */
		PIR1bits.RCIF = 0;
	}
}

#if	USART_USE_TX_INTERRUPT		// M荞݂gp.
void  USART_TxIntHandler(void)
{
//	if(	PIR1bits.TXIF==0 ) {		// Mobt@GveB`FbN.
	if(	PIR1bits.TXIF ) {			// Mobt@GveB`FbN.
		if( LastRS232Out ) {
			TXREG = RS232_Out_Data[RS232cp];	//PM.
			RS232cp++;
			if( RS232cp >= LastRS232Out ) {	//SI.
				LastRS232Out=0;
				PIE1bits.TXIE = 0;			// M荞݋.
			}
		}
		PIR1bits.TXIF=0;
	}
}
#endif

#else

//	--------------------------------
//		荞݂gpȂ.
//	--------------------------------

/********************************************************************
 *	PM
 ********************************************************************
 */
uchar getcUSART()
{
	char  c;

	if (RCSTAbits.OERR) { 	//	in case	of overrun error
					//	we should never	see	an overrun error, but if we	do,	
		RCSTAbits.CREN = 0;	 //	reset the port
		c =	RCREG;
		RCSTAbits.CREN = 1;	 //	and	keep going.
	}else{
		c =	RCREG;
	}
// not necessary.  EUSART auto clears the flag when	RCREG is cleared
//	PIR1bits.RCIF =	0;	  // clear Flag

	return c;
}


#endif

/********************************************************************
 *	PM
 ********************************************************************
 */
void putcUSART(char	c)
{
	TXREG =	c;
}


/********************************************************************
 *	n[hEFA.
 ********************************************************************
 */
void initUSART(void)
{
	uchar c;

#if	defined(__18F14K50)
	//ANSELHbits.ANS11 = 0;	// Make	RB5	digital	so USART can use pin for Rx
	ANSELH = 0;
	#ifndef	BAUDCON
		#define	BAUDCON	BAUDCTL
	#endif
#endif

	UART_TRISRx=1;			// RX s͂ɂ.
	UART_TRISTx=0;			// TX so͂ɂ.
	TXSTA =	0x24;			// TX enable BRGH=1
	RCSTA =	0x90;			// Single Character	RX
	SPBRG =	0x71;
	SPBRGH = 0x02;			// 0x0271 for 48MHz	-> 19200 baud
	BAUDCON	= 0x08;			// BRG16 = 1
	c =	RCREG;				// read	


#if	defined(USB_CDC_SUPPORT_HARDWARE_FLOW_CONTROL)
	// RTS,DTRMPORTɏo.
	UART_TRISRTS=0;				// TRISBbits.TRISB4
	UART_TRISDTR=0;				// TRISBbits.TRISB6
#endif

#if	USART_USE_INTERRUPT			// 荞݂gp.

	RCONbits.IPEN = 1; 			// 荞݃vCIeB(Low,High)Cl[u
	INTCONbits.GIEL = 1; 		// Low  Priority 荞݂.
	INTCONbits.GIEH = 1; 		// High Priority 荞݂.
	IPR1bits.RCIP = 1;		    // M荞݂High Priority .
	IPR1bits.TXIP = 0;		    // M荞݂Low  Priority .

	PIE1bits.RCIE = 1;		    // M荞݋.
	PIR1bits.RCIF = 0;			// M荞݃tOZbg.

	rxReadPtr = 0;
	rxWritePtr = 0;

#endif

}


/********************************************************************
 *
 ********************************************************************
 */
